!***************************************************************************
! FDVDEF.FOR  --  This is the include file for FMS applications in FORTRAN *
!***************************************************************************
!
!		      COPYRIGHT (c) 1982, 1983 BY
!	      DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.
!
! THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED
! ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE
! INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER
! COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
! OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY
! TRANSFERRED.
!
! THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE
! AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT
! CORPORATION.
!
! DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS
! SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
!
! Author: S.P.Simon
!
! Modification History:
! -002,	14-Mar-1986, James T. McCartney III
!	Added additional procedures and status return values for FMS 2.3
!
!************************
! FMS terminator codes: *
!************************
	INTEGER     FDV$K_FT_NTR
	PARAMETER ( FDV$K_FT_NTR     =  0 ) !Enter (i.e. end GETs)
	INTEGER	    FDV$K_FT_NXT     
	PARAMETER ( FDV$K_FT_NXT     =  1 ) !Next field 
	INTEGER     FDV$K_FT_PRV     
	PARAMETER ( FDV$K_FT_PRV     =  2 ) !Previous field 
	INTEGER     FDV$K_FT_ATB     
	PARAMETER ( FDV$K_FT_ATB     =  3 ) !Automatically move to next field
	INTEGER     FDV$K_FT_XBK     
	PARAMETER ( FDV$K_FT_XBK     =  4 ) !Exit scrolled area backward
	INTEGER     FDV$K_FT_XFW     
	PARAMETER ( FDV$K_FT_XFW     =  5 ) !Exit scrolled area forward
	INTEGER     FDV$K_FT_SNX     
	PARAMETER ( FDV$K_FT_SNX     =  6 ) !Scroll forward to next field 
	INTEGER     FDV$K_FT_SPR     
	PARAMETER ( FDV$K_FT_SPR     =  7 ) !Scroll backward to previous field
	INTEGER     FDV$K_FT_SFW     
	PARAMETER ( FDV$K_FT_SFW     =  8 ) !Scroll forward
	INTEGER     FDV$K_FT_SBK     
	PARAMETER ( FDV$K_FT_SBK     =  9 ) !Scroll backward
	INTEGER     FDV$K_FT_ILG_NXT 
	PARAMETER ( FDV$K_FT_ILG_NXT = 11 ) !Ilg ctxt: next field 
	INTEGER     FDV$K_FT_ILG_PRV 
	PARAMETER ( FDV$K_FT_ILG_PRV = 12 ) !Ilg ctxt: previous field 
	INTEGER     FDV$K_FT_ILG_ATB 
	PARAMETER ( FDV$K_FT_ILG_ATB = 13 ) !Ilg ctxt: auto move to next field
	INTEGER     FDV$K_FT_ILG_XBK 
	PARAMETER ( FDV$K_FT_ILG_XBK = 14 ) !Ilg ctxt: exit scr area backward
	INTEGER     FDV$K_FT_ILG_XFW 
	PARAMETER ( FDV$K_FT_ILG_XFW = 15 ) !Ilg ctxt: exit scr area forward
	INTEGER     FDV$K_FT_ILG_SFW 
	PARAMETER ( FDV$K_FT_ILG_SFW = 16 ) !Ilg ctxt: scroll forward
	INTEGER     FDV$K_FT_ILG_SBK 
	PARAMETER ( FDV$K_FT_ILG_SBK = 17 ) !Ilg ctxt: scroll backward
!*******************************************************
! Function key terminators returned from GETs and WAIT *
! Also used as FDV keycodes for use with DFKBD.        *
!*******************************************************
	INTEGER     FDV$K_AR_UP     
	PARAMETER ( FDV$K_AR_UP     =   99 )
	INTEGER     FDV$K_AR_DOWN   
	PARAMETER ( FDV$K_AR_DOWN   =  100 )
	INTEGER     FDV$K_AR_RIGHT
	PARAMETER ( FDV$K_AR_RIGHT  =  101 )
	INTEGER     FDV$K_AR_LEFT  
	PARAMETER ( FDV$K_AR_LEFT   =  102 )
	INTEGER     FDV$K_PF_1      
	PARAMETER ( FDV$K_PF_1      =  103 )
	INTEGER     FDV$K_PF_2      
	PARAMETER ( FDV$K_PF_2      =  104 )
	INTEGER     FDV$K_PF_3      
	PARAMETER ( FDV$K_PF_3      =  105 )
	INTEGER     FDV$K_PF_4      
	PARAMETER ( FDV$K_PF_4      =  106 )
	INTEGER     FDV$K_KP_NTR    
	PARAMETER ( FDV$K_KP_NTR    =  107 )
	INTEGER     FDV$K_KP_COM    
	PARAMETER ( FDV$K_KP_COM    =  108 )
	INTEGER     FDV$K_KP_HYP    
	PARAMETER ( FDV$K_KP_HYP    =  109 )
	INTEGER     FDV$K_KP_PER    
	PARAMETER ( FDV$K_KP_PER    =  110 )
	INTEGER     FDV$K_KP_0      
	PARAMETER ( FDV$K_KP_0      =  112 )
	INTEGER     FDV$K_KP_1      
	PARAMETER ( FDV$K_KP_1      =  113 )
	INTEGER     FDV$K_KP_2      
	PARAMETER ( FDV$K_KP_2      =  114 )
	INTEGER     FDV$K_KP_3      
	PARAMETER ( FDV$K_KP_3      =  115 )
	INTEGER     FDV$K_KP_4      
	PARAMETER ( FDV$K_KP_4      =  116 )
	INTEGER     FDV$K_KP_5      
	PARAMETER ( FDV$K_KP_5      =  117 )
	INTEGER     FDV$K_KP_6      
	PARAMETER ( FDV$K_KP_6      =  118 )
	INTEGER     FDV$K_KP_7      
	PARAMETER ( FDV$K_KP_7      =  119 )
	INTEGER     FDV$K_KP_8      
	PARAMETER ( FDV$K_KP_8      =  120 )
	INTEGER     FDV$K_KP_9      
	PARAMETER ( FDV$K_KP_9      =  121 )
	INTEGER     FDV$K_GAR_UP
	PARAMETER ( FDV$K_GAR_UP    =  227 )
	INTEGER     FDV$K_GAR_DOWN  
	PARAMETER ( FDV$K_GAR_DOWN  =  228 )
	INTEGER     FDV$K_GAR_RIGHT 
	PARAMETER ( FDV$K_GAR_RIGHT =  229 )
	INTEGER     FDV$K_GAR_LEFT  
	PARAMETER ( FDV$K_GAR_LEFT  =  230 )
	INTEGER     FDV$K_GPF_1     
	PARAMETER ( FDV$K_GPF_1     =  231 )
	INTEGER     FDV$K_GPF_2     
	PARAMETER ( FDV$K_GPF_2     =  232 )
	INTEGER     FDV$K_GPF_3     
	PARAMETER ( FDV$K_GPF_3     =  233 )
	INTEGER     FDV$K_GPF_4     
	PARAMETER ( FDV$K_GPF_4     =  234 )
	INTEGER     FDV$K_GKP_NTR   
	PARAMETER ( FDV$K_GKP_NTR   =  235 )
	INTEGER     FDV$K_GKP_COM   
	PARAMETER ( FDV$K_GKP_COM   =  236 )
	INTEGER     FDV$K_GKP_HYP   
	PARAMETER ( FDV$K_GKP_HYP   =  237 )
	INTEGER     FDV$K_GKP_PER   
	PARAMETER ( FDV$K_GKP_PER   =  238 )
	INTEGER     FDV$K_GKP_0     
	PARAMETER ( FDV$K_GKP_0     =  240 )
	INTEGER     FDV$K_GKP_1     
	PARAMETER ( FDV$K_GKP_1     =  241 )
	INTEGER     FDV$K_GKP_2     
	PARAMETER ( FDV$K_GKP_2     =  242 )
	INTEGER     FDV$K_GKP_3     
	PARAMETER ( FDV$K_GKP_3     =  243 )
	INTEGER     FDV$K_GKP_4     
	PARAMETER ( FDV$K_GKP_4     =  244 )
	INTEGER     FDV$K_GKP_5     
	PARAMETER ( FDV$K_GKP_5     =  245 )
	INTEGER     FDV$K_GKP_6     
	PARAMETER ( FDV$K_GKP_6     =  246 )
	INTEGER     FDV$K_GKP_7     
	PARAMETER ( FDV$K_GKP_7     =  247 )
	INTEGER     FDV$K_GKP_8     
	PARAMETER ( FDV$K_GKP_8     =  248 )
	INTEGER     FDV$K_GKP_9     
	PARAMETER ( FDV$K_GKP_9     =  249 )
	INTEGER     FDV$K_FK_E1
	PARAMETER ( FDV$K_FK_E1     =   33 )
	INTEGER     FDV$K_FK_E2
	PARAMETER ( FDV$K_FK_E2     =   34 )
	INTEGER     FDV$K_FK_E3
	PARAMETER ( FDV$K_FK_E3     =   35 )
	INTEGER     FDV$K_FK_E4
	PARAMETER ( FDV$K_FK_E4     =   36 )
	INTEGER     FDV$K_FK_E5
	PARAMETER ( FDV$K_FK_E5     =   37 )
	INTEGER     FDV$K_FK_E6
	PARAMETER ( FDV$K_FK_E6     =   38 )
	INTEGER     FDV$K_GFK_E1
	PARAMETER ( FDV$K_GFK_E1    =  161 )
	INTEGER     FDV$K_GFK_E2
	PARAMETER ( FDV$K_GFK_E2    =  162 )
	INTEGER     FDV$K_GFK_E3
	PARAMETER ( FDV$K_GFK_E3    =  163 )
	INTEGER     FDV$K_GFK_E4
	PARAMETER ( FDV$K_GFK_E4    =  164 )
	INTEGER     FDV$K_GFK_E5
	PARAMETER ( FDV$K_GFK_E5    =  165 )
	INTEGER     FDV$K_GFK_E6
	PARAMETER ( FDV$K_GFK_E6    =  166 )
	INTEGER     FDV$K_FK_F6
	PARAMETER ( FDV$K_FK_F6     =   49 )
	INTEGER     FDV$K_FK_F7
	PARAMETER ( FDV$K_FK_F7     =   50 )
	INTEGER     FDV$K_FK_F8
	PARAMETER ( FDV$K_FK_F8     =   51 )
	INTEGER     FDV$K_FK_F9
	PARAMETER ( FDV$K_FK_F9     =   52 )
	INTEGER     FDV$K_FK_F10
	PARAMETER ( FDV$K_FK_F10    =   53 )
	INTEGER     FDV$K_FK_F11
	PARAMETER ( FDV$K_FK_F11    =   55 )
	INTEGER     FDV$K_FK_F12
	PARAMETER ( FDV$K_FK_F12    =   56 )
	INTEGER     FDV$K_FK_F13
	PARAMETER ( FDV$K_FK_F13    =   57 )
	INTEGER     FDV$K_FK_F14
	PARAMETER ( FDV$K_FK_F14    =   58 )
	INTEGER     FDV$K_FK_HELP
	PARAMETER ( FDV$K_FK_HELP   =   60 )
	INTEGER     FDV$K_FK_DO
	PARAMETER ( FDV$K_FK_DO     =   61 )
	INTEGER     FDV$K_FK_F17
	PARAMETER ( FDV$K_FK_F17    =   63 )
	INTEGER     FDV$K_FK_F18
	PARAMETER ( FDV$K_FK_F18    =   64 )
	INTEGER     FDV$K_FK_F19
	PARAMETER ( FDV$K_FK_F19    =   65 )
	INTEGER     FDV$K_FK_F20
	PARAMETER ( FDV$K_FK_F20    =   66 )
	INTEGER     FDV$K_GFK_F6
	PARAMETER ( FDV$K_GFK_F6    =  177 )
	INTEGER     FDV$K_GFK_F7
	PARAMETER ( FDV$K_GFK_F7    =  178 )
	INTEGER     FDV$K_GFK_F8
	PARAMETER ( FDV$K_GFK_F8    =  179 )
	INTEGER     FDV$K_GFK_F9
	PARAMETER ( FDV$K_GFK_F9    =  180 )
	INTEGER     FDV$K_GFK_F10
	PARAMETER ( FDV$K_GFK_F10   =  181 )
	INTEGER     FDV$K_GFK_F11
	PARAMETER ( FDV$K_GFK_F11   =  183 )
	INTEGER     FDV$K_GFK_F12
	PARAMETER ( FDV$K_GFK_F12   =  184 )
	INTEGER     FDV$K_GFK_F13
	PARAMETER ( FDV$K_GFK_F13   =  185 )
	INTEGER     FDV$K_GFK_F14
	PARAMETER ( FDV$K_GFK_F14   =  186 )
	INTEGER     FDV$K_GFK_HELP
	PARAMETER ( FDV$K_GFK_HELP  =  188 )
	INTEGER     FDV$K_GFK_DO
	PARAMETER ( FDV$K_GFK_DO    =  189 )
	INTEGER     FDV$K_GFK_F17
	PARAMETER ( FDV$K_GFK_F17   =  191 )
	INTEGER     FDV$K_GFK_F18
	PARAMETER ( FDV$K_GFK_F18   =  192 )
	INTEGER     FDV$K_GFK_F19
	PARAMETER ( FDV$K_GFK_F19   =  193 )
	INTEGER     FDV$K_GFK_F20
	PARAMETER ( FDV$K_GFK_F20   =  194 )
!*******************************************
! FDV keyfunctions. For use in DFKBD call. *
!*******************************************
	INTEGER     FDV$K_KF_DLCHR 
	PARAMETER ( FDV$K_KF_DLCHR =   1 )
	INTEGER     FDV$K_KF_CRSRT 
	PARAMETER ( FDV$K_KF_CRSRT =   2 )
	INTEGER     FDV$K_KF_CRSLF 
	PARAMETER ( FDV$K_KF_CRSLF =   3 )
	INTEGER     FDV$K_KF_DLFLD 
	PARAMETER ( FDV$K_KF_DLFLD =   4 )
	INTEGER     FDV$K_KF_INS   
	PARAMETER ( FDV$K_KF_INS   =   5 )
	INTEGER     FDV$K_KF_OVR   
	PARAMETER ( FDV$K_KF_OVR   =   6 )
	INTEGER     FDV$K_KF_GOLD  
	PARAMETER ( FDV$K_KF_GOLD  =   7 )
	INTEGER     FDV$K_KF_RESET 
	PARAMETER ( FDV$K_KF_RESET =   8 )
	INTEGER     FDV$K_KF_RFRSH 
	PARAMETER ( FDV$K_KF_RFRSH =   9 )
	INTEGER     FDV$K_KF_HELP  
	PARAMETER ( FDV$K_KF_HELP  =  10 )
	INTEGER     FDV$K_KF_NXT   
	PARAMETER ( FDV$K_KF_NXT   =  11 )
	INTEGER     FDV$K_KF_PRV   
	PARAMETER ( FDV$K_KF_PRV   =  12 )
	INTEGER     FDV$K_KF_NTR   
	PARAMETER ( FDV$K_KF_NTR   =  13 )
	INTEGER     FDV$K_KF_SBK   
	PARAMETER ( FDV$K_KF_SBK   =  14 )
	INTEGER     FDV$K_KF_SFW   
	PARAMETER ( FDV$K_KF_SFW   =  15 )
	INTEGER     FDV$K_KF_XBK   
	PARAMETER ( FDV$K_KF_XBK   =  16 )
	INTEGER     FDV$K_KF_XFW   
	PARAMETER ( FDV$K_KF_XFW   =  17 )
	INTEGER     FDV$K_KF_NONE
	PARAMETER ( FDV$K_KF_NONE  =   0 )
	INTEGER     FDV$K_KF_DFLT
	PARAMETER ( FDV$K_KF_DFLT   = -1 )
!************************************************************
! UAR return codes. These codes are returned by UAR to FDV. *
!************************************************************
! Field completion return codes *
!********************************
	INTEGER     FDV$K_UVAL_SUC 
	PARAMETER ( FDV$K_UVAL_SUC =  1000 )	!Field completion success
	INTEGER     FDV$K_UVAL_FAIL
	PARAMETER ( FDV$K_UVAL_FAIL = 1001 )	!Field completion failure
	INTEGER     FDV$K_UVAL_END
	PARAMETER ( FDV$K_UVAL_END =  1002 )	!Field completion suc-stop UAR
!************************
! Help UAR return codes *
!************************
	INTEGER     FDV$K_UHELP_NO 
	PARAMETER ( FDV$K_UHELP_NO =  2000 )	!No help given, try next step
	INTEGER     FDV$K_UHELPED  
	PARAMETER ( FDV$K_UHELPED  =  2001 )	!Help given, continue sequence
	INTEGER     FDV$K_UHELP_ALL  
	PARAMETER ( FDV$K_UHELP_ALL = 2002 )	!Help given, repeat UAR	
!********************************
! Function Key UAR return codes *
!********************************
	INTEGER     FDV$K_UKEY_ERR 
	PARAMETER ( FDV$K_UKEY_ERR =  3000 )	!Fn Key failure, FDV signals
	INTEGER     FDV$K_UKEY_TRM 
	PARAMETER ( FDV$K_UKEY_TRM =  3001 )	!Fn Key success, normal f.k.
	INTEGER     FDV$K_UKEY_NXT 
	PARAMETER ( FDV$K_UKEY_NXT =  3002 )	!Fn Key succ, treat as NEXT
	INTEGER     FDV$K_UKEY_NTR 
	PARAMETER ( FDV$K_UKEY_NTR =  3003 )	!Fn Key succ, treat as ENTER
	INTEGER     FDV$K_UKEY_SUC 
	PARAMETER ( FDV$K_UKEY_SUC =  3004 )	!Fn Key succ, ignore	
!***************************************************************************
! FDV status codes returned when FDV$... routines are called as functions. *
! These codes are VMS status codes and can be signalled.  They correspond  *
! one-to-one with the FMS status codes retrievable from FDV$STAT.  	   *
!***************************************************************************
	INTEGER FDV$_SUC
	PARAMETER ( FDV$_SUC = 2719889 )
	INTEGER FDV$_INC
	PARAMETER ( FDV$_INC = 2719897 )
	INTEGER FDV$_MOD
	PARAMETER ( FDV$_MOD = 2719905 )
	INTEGER FDV$_IMP
	PARAMETER ( FDV$_IMP = 2719922 )
	INTEGER FDV$_FSP
	PARAMETER ( FDV$_FSP = 2719930 )
	INTEGER FDV$_IOL
	PARAMETER ( FDV$_IOL = 2719938 )
	INTEGER FDV$_FLB
	PARAMETER ( FDV$_FLB = 2719946 )
	INTEGER FDV$_ICH
	PARAMETER ( FDV$_ICH = 2719954 )
	INTEGER FDV$_FCH
	PARAMETER ( FDV$_FCH = 2719962 )
	INTEGER FDV$_FRM
	PARAMETER ( FDV$_FRM = 2719970 )
	INTEGER FDV$_FNM
	PARAMETER ( FDV$_FNM = 2719978 )
	INTEGER FDV$_LIN
	PARAMETER ( FDV$_LIN = 2719986 )
	INTEGER FDV$_FLD
	PARAMETER ( FDV$_FLD = 2719994 )
	INTEGER FDV$_NOF
	PARAMETER ( FDV$_NOF = 2720002 )
	INTEGER FDV$_DSP
	PARAMETER ( FDV$_DSP = 2720010 )
	INTEGER FDV$_NSC
	PARAMETER ( FDV$_NSC = 2720018 )
	INTEGER FDV$_DNM
	PARAMETER ( FDV$_DNM = 2720026 )
	INTEGER FDV$_DLN
	PARAMETER ( FDV$_DLN = 2720034 )
	INTEGER FDV$_UTR
	PARAMETER ( FDV$_UTR = 2720042 )
	INTEGER FDV$_IOR
	PARAMETER ( FDV$_IOR = 2720050 )
	INTEGER FDV$_IFN
	PARAMETER ( FDV$_IFN = 2720058 )
	INTEGER FDV$_ARG
	PARAMETER ( FDV$_ARG = 2720066 )
	INTEGER FDV$_INI
	PARAMETER ( FDV$_INI = 2720074 )
	INTEGER FDV$_STR
	PARAMETER ( FDV$_STR = 2720082 )
	INTEGER FDV$_IVM
	PARAMETER ( FDV$_IVM = 2720090 )
	INTEGER FDV$_FVM
	PARAMETER ( FDV$_FVM = 2720098 )
	INTEGER FDV$_ITT
	PARAMETER ( FDV$_ITT = 2720106 )
	INTEGER FDV$_TCA
	PARAMETER ( FDV$_TCA = 2720114 )
	INTEGER FDV$_STA
	PARAMETER ( FDV$_STA = 2720122 )
	INTEGER FDV$_WID
	PARAMETER ( FDV$_WID = 2720130 )
	INTEGER FDV$_NFL
	PARAMETER ( FDV$_NFL = 2720138 )
	INTEGER FDV$_IBF
	PARAMETER ( FDV$_IBF = 2720146 )
	INTEGER FDV$_NDS
	PARAMETER ( FDV$_NDS = 2720154 )
	INTEGER FDV$_UDP
	PARAMETER ( FDV$_UDP = 2720162 )
	INTEGER FDV$_UAR
	PARAMETER ( FDV$_UAR = 2720170 )
	INTEGER FDV$_UNF
	PARAMETER ( FDV$_UNF = 2720178 )
	INTEGER FDV$_CAN
	PARAMETER ( FDV$_CAN = 2720194 )
	INTEGER FDV$_KIF
	PARAMETER ( FDV$_KIF = 2720202 )
	INTEGER FDV$_KEX
	PARAMETER ( FDV$_KEX = 2720210 )
	INTEGER FDV$_KTW
	PARAMETER ( FDV$_KTW = 2720218 )
	INTEGER FDV$_KIL
	PARAMETER ( FDV$_KIL = 2720226 )
	INTEGER FDV$_TMO
	PARAMETER ( FDV$_TMO = 2720234 )
	INTEGER FDV$_LLI
	PARAMETER ( FDV$_LLI = 2720242 )
	INTEGER FDV$_VAL
	PARAMETER ( FDV$_VAL = 2720250 )
	INTEGER FDV$_IFU
	PARAMETER ( FDV$_IFU = 2720258 )
	INTEGER FDV$_SYS
	PARAMETER ( FDV$_SYS = 2720266 )
	INTEGER FDV$_INA
	PARAMETER ( FDV$_INA = 2720274 )
	INTEGER FDV$_IOO
	PARAMETER ( FDV$_IOO = 2720282 )

!**************************************************************************
! FMS status codes returned when FDV$STAT routine is called.		  *
!**************************************************************************
! Success codes.

	INTEGER     FDV$K_SUC 
	PARAMETER ( FDV$K_SUC =	 1 )
	INTEGER     FDV$K_INC 
	PARAMETER ( FDV$K_INC =	 2 )
	INTEGER     FDV$K_MOD 
	PARAMETER ( FDV$K_MOD =	 3 )

! Failure codes

	INTEGER     FDV$K_IMP 
	PARAMETER ( FDV$K_IMP =	 -2 )
	INTEGER     FDV$K_FSP 
	PARAMETER ( FDV$K_FSP =	 -3 )
	INTEGER     FDV$K_IOL 
	PARAMETER ( FDV$K_IOL =	 -4 )
	INTEGER     FDV$K_FLB 
	PARAMETER ( FDV$K_FLB =	 -5 )
	INTEGER     FDV$K_ICH 
	PARAMETER ( FDV$K_ICH =	 -6 )
	INTEGER     FDV$K_FCH 
	PARAMETER ( FDV$K_FCH =	 -7 )
	INTEGER     FDV$K_FRM 
	PARAMETER ( FDV$K_FRM =	 -8 )
	INTEGER     FDV$K_FNM 
	PARAMETER ( FDV$K_FNM =	 -9 )
	INTEGER     FDV$K_LIN 
	PARAMETER ( FDV$K_LIN =	 -10 )
	INTEGER     FDV$K_FLD 
	PARAMETER ( FDV$K_FLD =	 -11 )
	INTEGER     FDV$K_NOF 
	PARAMETER ( FDV$K_NOF =	 -12 )
	INTEGER     FDV$K_DSP 
	PARAMETER ( FDV$K_DSP =	 -13 )
	INTEGER     FDV$K_NSC 
	PARAMETER ( FDV$K_NSC =	 -14 )
	INTEGER     FDV$K_DNM 
	PARAMETER ( FDV$K_DNM =	 -15 )
	INTEGER     FDV$K_DLN 
	PARAMETER ( FDV$K_DLN =	 -16 )
	INTEGER     FDV$K_UTR 
	PARAMETER ( FDV$K_UTR =	 -17 )
	INTEGER     FDV$K_IOR 
	PARAMETER ( FDV$K_IOR =	 -18 )
	INTEGER     FDV$K_IFN 
	PARAMETER ( FDV$K_IFN =	 -19 )
	INTEGER     FDV$K_ARG 
	PARAMETER ( FDV$K_ARG =	 -20 )
	INTEGER     FDV$K_INI 
	PARAMETER ( FDV$K_INI =	 -21 )
	INTEGER     FDV$K_STR 
	PARAMETER ( FDV$K_STR =	 -22 )
	INTEGER     FDV$K_FVM 
	PARAMETER ( FDV$K_FVM =	 -23 )
	INTEGER     FDV$K_IVM 
	PARAMETER ( FDV$K_IVM =	 -24 )
	INTEGER     FDV$K_ITT 
	PARAMETER ( FDV$K_ITT =	 -25 )
	INTEGER     FDV$K_TCA 
	PARAMETER ( FDV$K_TCA =	 -26 )
	INTEGER     FDV$K_STA 
	PARAMETER ( FDV$K_STA =	 -27 )
	INTEGER     FDV$K_WID 
	PARAMETER ( FDV$K_WID =	 -28 )
	INTEGER     FDV$K_NFL 
	PARAMETER ( FDV$K_NFL =	 -29 )
	INTEGER     FDV$K_IBF 
	PARAMETER ( FDV$K_IBF =	 -30 )
	INTEGER     FDV$K_NDS 
	PARAMETER ( FDV$K_NDS =	 -31 )
	INTEGER     FDV$K_UDP 
	PARAMETER ( FDV$K_UDP =	 -33 )
	INTEGER     FDV$K_UAR 
	PARAMETER ( FDV$K_UAR =	 -34 )
	INTEGER     FDV$K_UNF 
	PARAMETER ( FDV$K_UNF =	 -35 )
	INTEGER     FDV$K_CAN 
	PARAMETER ( FDV$K_CAN =	 -39 )
	INTEGER     FDV$K_KIF 
	PARAMETER ( FDV$K_KIF =	 -40 )
	INTEGER     FDV$K_KEX 
	PARAMETER ( FDV$K_KEX =	 -41 )
	INTEGER     FDV$K_KTW 
	PARAMETER ( FDV$K_KTW =	 -42 )
	INTEGER     FDV$K_KIL 
	PARAMETER ( FDV$K_KIL =	 -43 )
	INTEGER     FDV$K_TMO 
	PARAMETER ( FDV$K_TMO =	 -44 )
	INTEGER     FDV$K_LLI 
	PARAMETER ( FDV$K_LLI =	 -45 )
	INTEGER     FDV$K_VAL 
	PARAMETER ( FDV$K_VAL =	 -47 )
	INTEGER     FDV$K_IFU 
	PARAMETER ( FDV$K_IFU =	 -48 )
	INTEGER     FDV$K_SYS 
	PARAMETER ( FDV$K_SYS =	 -49 )
	INTEGER     FDV$K_INA 
	PARAMETER ( FDV$K_INA =	 -50 )
	INTEGER     FDV$K_IOO
	PARAMETER ( FDV$K_IOO =  -51 )

!********************************************************
! Declare the FDV routines				*
!********************************************************
	INTEGER FDV$ADLVA
	INTEGER FDV$AFCX
	INTEGER FDV$AFVA
	INTEGER FDV$ATERM
	INTEGER FDV$AWKSP
	INTEGER FDV$BELL 
	INTEGER FDV$CANCL
	INTEGER FDV$CDISP
	INTEGER FDV$CLEAR
	INTEGER FDV$CLEAR_VA
	INTEGER FDV$DEL 
	INTEGER FDV$DFKBD
	INTEGER FDV$DISP
	INTEGER FDV$DISPW
	INTEGER FDV$DPCOM
	INTEGER FDV$DTERM 
	INTEGER FDV$DWKSP 
	INTEGER FDV$FCHAN
	INTEGER FDV$FIX_SCREEN
	INTEGER FDV$GET 
	INTEGER FDV$GETAF 
	INTEGER FDV$GETAL
	INTEGER FDV$GETDL
	INTEGER FDV$GETSC
	INTEGER FDV$ILTRM
	INTEGER FDV$LCHAN
	INTEGER FDV$LCLOS 
	INTEGER FDV$LEDOF 
	INTEGER FDV$LEDON 
	INTEGER FDV$LOAD 
	INTEGER FDV$LOPEN
	INTEGER FDV$NDISP
	INTEGER FDV$PFT 
	INTEGER FDV$PRINT_SCREEN
	INTEGER FDV$PUT 
	INTEGER FDV$PUTAL 
	INTEGER FDV$PUTD 
	INTEGER FDV$PUTDA
	INTEGER FDV$PUTL 
	INTEGER FDV$PUTSC 
	INTEGER FDV$READ 
	INTEGER FDV$RET 
	INTEGER FDV$RETAL 
	INTEGER FDV$RETCX
	INTEGER FDV$RETDI 
	INTEGER FDV$RETDN 
	INTEGER FDV$RETFL 
	INTEGER FDV$RETFN 
	INTEGER FDV$RETFO
	INTEGER FDV$RETLE
	INTEGER FDV$RFRSH
	INTEGER FDV$SCR_LENGTH
	INTEGER FDV$SCR_WIDTH
	INTEGER FDV$SIGOP 
	INTEGER FDV$SPADA 
	INTEGER FDV$SPOFF 
	INTEGER FDV$SPON 
	INTEGER FDV$SSIGQ 
	INTEGER FDV$SSRV 
	INTEGER FDV$STAT 
	INTEGER FDV$STERM
	INTEGER FDV$STIME
	INTEGER FDV$SWKSP 
	INTEGER FDV$TCHAN
	INTEGER FDV$USER_REFRESH
	INTEGER FDV$WAIT 
