!***********************************************************************
! FDVDEF.BAS  --  This is the include file for FMS applications in BASIC
!***********************************************************************
!
!		      COPYRIGHT (c) 1982, 1983 BY
!	      DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.
!
! THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED
! ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE
! INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER
! COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
! OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY
! TRANSFERRED.
!
! THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE
! AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT
! CORPORATION.
!
! DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS
! SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
!
! Author: S.P.Simon
!
! Modification History:
! -002, 14-Mar-1986 James T. McCartney III
!	Added additional procedures and status return values for FMS 2.3
!
!***********************
! FMS terminator codes: 
!***********************
DECLARE INTEGER CONSTANT FDV$K_FT_NTR     =  0	!Enter (i.e. end GETs)
DECLARE INTEGER CONSTANT FDV$K_FT_NXT     =  1	!Next field 
DECLARE INTEGER CONSTANT FDV$K_FT_PRV     =  2	!Previous field 
DECLARE INTEGER CONSTANT FDV$K_FT_ATB     =  3	!Automatically move to next field
DECLARE INTEGER CONSTANT FDV$K_FT_XBK     =  4	!Exit scrolled area backward
DECLARE INTEGER CONSTANT FDV$K_FT_XFW     =  5	!Exit scrolled area forward
DECLARE INTEGER CONSTANT FDV$K_FT_SNX     =  6	!Scroll forward to next field 
DECLARE INTEGER CONSTANT FDV$K_FT_SPR     =  7	!Scroll backward to previous field
DECLARE INTEGER CONSTANT FDV$K_FT_SFW     =  8	!Scroll forward
DECLARE INTEGER CONSTANT FDV$K_FT_SBK     =  9	!Scroll backward
DECLARE INTEGER CONSTANT FDV$K_FT_ILG_NXT = 11	!Illegal context for next field 
DECLARE INTEGER CONSTANT FDV$K_FT_ILG_PRV = 12	!Illegal context for previous field 
DECLARE INTEGER CONSTANT FDV$K_FT_ILG_ATB = 13	!Illegal context for auto move to next field
DECLARE INTEGER CONSTANT FDV$K_FT_ILG_XBK = 14	!Illegal context for exit scrolled area backward
DECLARE INTEGER CONSTANT FDV$K_FT_ILG_XFW = 15	!Illegal context for exit scrolled area forward
DECLARE INTEGER CONSTANT FDV$K_FT_ILG_SFW = 16	!Illegal context for scroll forward
DECLARE INTEGER CONSTANT FDV$K_FT_ILG_SBK = 17	!Illegal context for scroll backward
!******************************************************
! Function key terminators returned from GETs and WAIT 
! Also used as FDV keycodes for use with DFKBD. 	
!******************************************************
DECLARE INTEGER CONSTANT FDV$K_AR_UP     =   99
DECLARE INTEGER CONSTANT FDV$K_AR_DOWN   =  100
DECLARE INTEGER CONSTANT FDV$K_AR_RIGHT  =  101
DECLARE INTEGER CONSTANT FDV$K_AR_LEFT   =  102
DECLARE INTEGER CONSTANT FDV$K_PF_1      =  103
DECLARE INTEGER CONSTANT FDV$K_PF_2      =  104
DECLARE INTEGER CONSTANT FDV$K_PF_3      =  105
DECLARE INTEGER CONSTANT FDV$K_PF_4      =  106
DECLARE INTEGER CONSTANT FDV$K_KP_NTR    =  107
DECLARE INTEGER CONSTANT FDV$K_KP_COM    =  108
DECLARE INTEGER CONSTANT FDV$K_KP_HYP    =  109
DECLARE INTEGER CONSTANT FDV$K_KP_PER    =  110
DECLARE INTEGER CONSTANT FDV$K_KP_0      =  112
DECLARE INTEGER CONSTANT FDV$K_KP_1      =  113
DECLARE INTEGER CONSTANT FDV$K_KP_2      =  114
DECLARE INTEGER CONSTANT FDV$K_KP_3      =  115
DECLARE INTEGER CONSTANT FDV$K_KP_4      =  116
DECLARE INTEGER CONSTANT FDV$K_KP_5      =  117
DECLARE INTEGER CONSTANT FDV$K_KP_6      =  118
DECLARE INTEGER CONSTANT FDV$K_KP_7      =  119
DECLARE INTEGER CONSTANT FDV$K_KP_8      =  120
DECLARE INTEGER CONSTANT FDV$K_KP_9      =  121
DECLARE INTEGER CONSTANT FDV$K_GAR_UP    =  227
DECLARE INTEGER CONSTANT FDV$K_GAR_DOWN  =  228
DECLARE INTEGER CONSTANT FDV$K_GAR_RIGHT =  229
DECLARE INTEGER CONSTANT FDV$K_GAR_LEFT  =  230
DECLARE INTEGER CONSTANT FDV$K_GPF_1     =  231
DECLARE INTEGER CONSTANT FDV$K_GPF_2     =  232
DECLARE INTEGER CONSTANT FDV$K_GPF_3     =  233
DECLARE INTEGER CONSTANT FDV$K_GPF_4     =  234
DECLARE INTEGER CONSTANT FDV$K_GKP_NTR   =  235
DECLARE INTEGER CONSTANT FDV$K_GKP_COM   =  236
DECLARE INTEGER CONSTANT FDV$K_GKP_HYP   =  237
DECLARE INTEGER CONSTANT FDV$K_GKP_PER   =  238
DECLARE INTEGER CONSTANT FDV$K_GKP_0     =  240
DECLARE INTEGER CONSTANT FDV$K_GKP_1     =  241
DECLARE INTEGER CONSTANT FDV$K_GKP_2     =  242
DECLARE INTEGER CONSTANT FDV$K_GKP_3     =  243
DECLARE INTEGER CONSTANT FDV$K_GKP_4     =  244
DECLARE INTEGER CONSTANT FDV$K_GKP_5     =  245
DECLARE INTEGER CONSTANT FDV$K_GKP_6     =  246
DECLARE INTEGER CONSTANT FDV$K_GKP_7     =  247
DECLARE INTEGER CONSTANT FDV$K_GKP_8     =  248
DECLARE INTEGER CONSTANT FDV$K_GKP_9     =  249
DECLARE INTEGER CONSTANT FDV$K_FK_E1     =  33
DECLARE INTEGER CONSTANT FDV$K_FK_E2     =  34
DECLARE INTEGER CONSTANT FDV$K_FK_E3     =  35
DECLARE INTEGER CONSTANT FDV$K_FK_E4     =  36
DECLARE INTEGER CONSTANT FDV$K_FK_E5     =  37
DECLARE INTEGER CONSTANT FDV$K_FK_E6     =  38
DECLARE INTEGER CONSTANT FDV$K_GFK_E1    =  161
DECLARE INTEGER CONSTANT FDV$K_GFK_E2    =  162
DECLARE INTEGER CONSTANT FDV$K_GFK_E3    =  163
DECLARE INTEGER CONSTANT FDV$K_GFK_E4    =  164
DECLARE INTEGER CONSTANT FDV$K_GFK_E5    =  165
DECLARE INTEGER CONSTANT FDV$K_GFK_E6    =  166
DECLARE INTEGER CONSTANT FDV$K_FK_F6     =  49
DECLARE INTEGER CONSTANT FDV$K_FK_F7     =  50
DECLARE INTEGER CONSTANT FDV$K_FK_F8     =  51
DECLARE INTEGER CONSTANT FDV$K_FK_F9     =  52
DECLARE INTEGER CONSTANT FDV$K_FK_F10    =  53
DECLARE INTEGER CONSTANT FDV$K_FK_F11    =  55
DECLARE INTEGER CONSTANT FDV$K_FK_F12    =  56
DECLARE INTEGER CONSTANT FDV$K_FK_F13    =  57
DECLARE INTEGER CONSTANT FDV$K_FK_F14    =  58
DECLARE INTEGER CONSTANT FDV$K_FK_HELP   =  60
DECLARE INTEGER CONSTANT FDV$K_FK_DO     =  61
DECLARE INTEGER CONSTANT FDV$K_FK_F17    =  63
DECLARE INTEGER CONSTANT FDV$K_FK_F18    =  64
DECLARE INTEGER CONSTANT FDV$K_FK_F19    =  65
DECLARE INTEGER CONSTANT FDV$K_FK_F20    =  66
DECLARE INTEGER CONSTANT FDV$K_GFK_F6    =  177
DECLARE INTEGER CONSTANT FDV$K_GFK_F7    =  178
DECLARE INTEGER CONSTANT FDV$K_GFK_F8    =  179
DECLARE INTEGER CONSTANT FDV$K_GFK_F9    =  180
DECLARE INTEGER CONSTANT FDV$K_GFK_F10   =  181
DECLARE INTEGER CONSTANT FDV$K_GFK_F11   =  183
DECLARE INTEGER CONSTANT FDV$K_GFK_F12   =  184
DECLARE INTEGER CONSTANT FDV$K_GFK_F13   =  185
DECLARE INTEGER CONSTANT FDV$K_GFK_F14   =  186
DECLARE INTEGER CONSTANT FDV$K_GFK_HELP  =  188
DECLARE INTEGER CONSTANT FDV$K_GFK_DO    =  189
DECLARE INTEGER CONSTANT FDV$K_GFK_F17   =  191
DECLARE INTEGER CONSTANT FDV$K_GFK_F18   =  192
DECLARE INTEGER CONSTANT FDV$K_GFK_F19   =  193
DECLARE INTEGER CONSTANT FDV$K_GFK_F20   =  194
!******************************************
! FDV keyfunctions. For use in DFKBD call. 
!******************************************
DECLARE INTEGER CONSTANT FDV$K_KF_DLCHR =   1
DECLARE INTEGER CONSTANT FDV$K_KF_CRSRT =   2
DECLARE INTEGER CONSTANT FDV$K_KF_CRSLF =   3
DECLARE INTEGER CONSTANT FDV$K_KF_DLFLD =   4
DECLARE INTEGER CONSTANT FDV$K_KF_INS   =   5
DECLARE INTEGER CONSTANT FDV$K_KF_OVR   =   6
DECLARE INTEGER CONSTANT FDV$K_KF_GOLD  =   7
DECLARE INTEGER CONSTANT FDV$K_KF_RESET =   8
DECLARE INTEGER CONSTANT FDV$K_KF_RFRSH =   9
DECLARE INTEGER CONSTANT FDV$K_KF_HELP  =  10
DECLARE INTEGER CONSTANT FDV$K_KF_NXT   =  11
DECLARE INTEGER CONSTANT FDV$K_KF_PRV   =  12
DECLARE INTEGER CONSTANT FDV$K_KF_NTR   =  13
DECLARE INTEGER CONSTANT FDV$K_KF_SBK   =  14
DECLARE INTEGER CONSTANT FDV$K_KF_SFW   =  15
DECLARE INTEGER CONSTANT FDV$K_KF_XBK   =  16
DECLARE INTEGER CONSTANT FDV$K_KF_XFW   =  17
DECLARE INTEGER CONSTANT FDV$K_KF_NONE  =   0
DECLARE INTEGER CONSTANT FDV$K_KF_DFLT  =  -1
!***********************************************************
! UAR return codes. These codes are returned by UAR to FDV. 
!***********************************************************
! Field completion return codes 
!*******************************
DECLARE INTEGER CONSTANT FDV$K_UVAL_SUC =  1000	!Field completion success
DECLARE INTEGER CONSTANT FDV$K_UVAL_FAIL=  1001	!Field completion failure
DECLARE INTEGER CONSTANT FDV$K_UVAL_END	=  1002	!Field completion suc-stop UARs
!***********************
! Help UAR return codes 
!***********************
DECLARE INTEGER CONSTANT FDV$K_UHELP_NO =  2000	!No help given, try next step
DECLARE INTEGER CONSTANT FDV$K_UHELPED  =  2001	!Help given, continue sequence
DECLARE INTEGER CONSTANT FDV$K_UHELP_ALL=  2002	!Help given, repeat UAR	
!*******************************
! Function Key UAR return codes 
!*******************************
DECLARE INTEGER CONSTANT FDV$K_UKEY_ERR =  3000	!Fn Key failure, FDV signals
DECLARE INTEGER CONSTANT FDV$K_UKEY_TRM =  3001	!Fn Key success, normal f.k.
DECLARE INTEGER CONSTANT FDV$K_UKEY_NXT =  3002	!Fn Key succ, treat as NEXT
DECLARE INTEGER CONSTANT FDV$K_UKEY_NTR =  3003	!Fn Key succ, treat as ENTER
DECLARE INTEGER CONSTANT FDV$K_UKEY_SUC =  3004	!Fn Key succ, ignore	
!**************************************************************************
! FDV status codes returned when FDV$... routines are called as functions. 
! These codes are VMS status codes and can be signalled.  They correspond  
! one-to-one with the FMS status codes retrievable from FDV$STAT.
!**************************************************************************
DECLARE INTEGER CONSTANT FDV$_SUC = 2719889
DECLARE INTEGER CONSTANT FDV$_INC = 2719897
DECLARE INTEGER CONSTANT FDV$_MOD = 2719905
DECLARE INTEGER CONSTANT FDV$_IMP = 2719922
DECLARE INTEGER CONSTANT FDV$_FSP = 2719930
DECLARE INTEGER CONSTANT FDV$_IOL = 2719938
DECLARE INTEGER CONSTANT FDV$_FLB = 2719946
DECLARE INTEGER CONSTANT FDV$_ICH = 2719954
DECLARE INTEGER CONSTANT FDV$_FCH = 2719962
DECLARE INTEGER CONSTANT FDV$_FRM = 2719970
DECLARE INTEGER CONSTANT FDV$_FNM = 2719978
DECLARE INTEGER CONSTANT FDV$_LIN = 2719986
DECLARE INTEGER CONSTANT FDV$_FLD = 2719994
DECLARE INTEGER CONSTANT FDV$_NOF = 2720002
DECLARE INTEGER CONSTANT FDV$_DSP = 2720010
DECLARE INTEGER CONSTANT FDV$_NSC = 2720018
DECLARE INTEGER CONSTANT FDV$_DNM = 2720026
DECLARE INTEGER CONSTANT FDV$_DLN = 2720034
DECLARE INTEGER CONSTANT FDV$_UTR = 2720042
DECLARE INTEGER CONSTANT FDV$_IOR = 2720050
DECLARE INTEGER CONSTANT FDV$_IFN = 2720058
DECLARE INTEGER CONSTANT FDV$_ARG = 2720066
DECLARE INTEGER CONSTANT FDV$_INI = 2720074
DECLARE INTEGER CONSTANT FDV$_STR = 2720082
DECLARE INTEGER CONSTANT FDV$_IVM = 2720090
DECLARE INTEGER CONSTANT FDV$_FVM = 2720098
DECLARE INTEGER CONSTANT FDV$_ITT = 2720106
DECLARE INTEGER CONSTANT FDV$_TCA = 2720114
DECLARE INTEGER CONSTANT FDV$_STA = 2720122
DECLARE INTEGER CONSTANT FDV$_WID = 2720130
DECLARE INTEGER CONSTANT FDV$_NFL = 2720138
DECLARE INTEGER CONSTANT FDV$_IBF = 2720146
DECLARE INTEGER CONSTANT FDV$_NDS = 2720154
DECLARE INTEGER CONSTANT FDV$_UDP = 2720162
DECLARE INTEGER CONSTANT FDV$_UAR = 2720170
DECLARE INTEGER CONSTANT FDV$_UNF = 2720178
DECLARE INTEGER CONSTANT FDV$_CAN = 2720194
DECLARE INTEGER CONSTANT FDV$_KIF = 2720202
DECLARE INTEGER CONSTANT FDV$_KEX = 2720210
DECLARE INTEGER CONSTANT FDV$_KTW = 2720218
DECLARE INTEGER CONSTANT FDV$_KIL = 2720226
DECLARE INTEGER CONSTANT FDV$_TMO = 2720234
DECLARE INTEGER CONSTANT FDV$_LLI = 2720242
DECLARE INTEGER CONSTANT FDV$_VAL = 2720250
DECLARE INTEGER CONSTANT FDV$_IFU = 2720258
DECLARE INTEGER CONSTANT FDV$_SYS = 2720266
DECLARE INTEGER CONSTANT FDV$_INA = 2720274
DECLARE INTEGER CONSTANT FDV$_IOO = 2720282

!**************************************************************************
! FMS status codes returned when FDV$STAT routine is called.
!**************************************************************************
! Success codes.

DECLARE INTEGER CONSTANT FDV$K_SUC =	1
DECLARE INTEGER CONSTANT FDV$K_INC =	2
DECLARE INTEGER CONSTANT FDV$K_MOD =	3

! Failure codes

DECLARE INTEGER CONSTANT FDV$K_IMP =	-2
DECLARE INTEGER CONSTANT FDV$K_FSP =	-3
DECLARE INTEGER CONSTANT FDV$K_IOL =	-4
DECLARE INTEGER CONSTANT FDV$K_FLB =	-5
DECLARE INTEGER CONSTANT FDV$K_ICH =	-6
DECLARE INTEGER CONSTANT FDV$K_FCH =	-7
DECLARE INTEGER CONSTANT FDV$K_FRM =	-8
DECLARE INTEGER CONSTANT FDV$K_FNM =	-9
DECLARE INTEGER CONSTANT FDV$K_LIN =	-10
DECLARE INTEGER CONSTANT FDV$K_FLD =	-11
DECLARE INTEGER CONSTANT FDV$K_NOF =	-12
DECLARE INTEGER CONSTANT FDV$K_DSP =	-13
DECLARE INTEGER CONSTANT FDV$K_NSC =	-14
DECLARE INTEGER CONSTANT FDV$K_DNM =	-15
DECLARE INTEGER CONSTANT FDV$K_DLN =	-16
DECLARE INTEGER CONSTANT FDV$K_UTR =	-17
DECLARE INTEGER CONSTANT FDV$K_IOR =	-18
DECLARE INTEGER CONSTANT FDV$K_IFN =	-19
DECLARE INTEGER CONSTANT FDV$K_ARG =	-20
DECLARE INTEGER CONSTANT FDV$K_INI =	-21
DECLARE INTEGER CONSTANT FDV$K_STR =	-22
DECLARE INTEGER CONSTANT FDV$K_FVM =	-23
DECLARE INTEGER CONSTANT FDV$K_IVM =	-24
DECLARE INTEGER CONSTANT FDV$K_ITT =	-25
DECLARE INTEGER CONSTANT FDV$K_TCA =	-26
DECLARE INTEGER CONSTANT FDV$K_STA =	-27
DECLARE INTEGER CONSTANT FDV$K_WID =	-28
DECLARE INTEGER CONSTANT FDV$K_NFL =	-29
DECLARE INTEGER CONSTANT FDV$K_IBF =	-30
DECLARE INTEGER CONSTANT FDV$K_NDS =	-31
DECLARE INTEGER CONSTANT FDV$K_UDP =	-33
DECLARE INTEGER CONSTANT FDV$K_UAR =	-34
DECLARE INTEGER CONSTANT FDV$K_UNF =	-35
DECLARE INTEGER CONSTANT FDV$K_CAN =	-39
DECLARE INTEGER CONSTANT FDV$K_KIF =	-40
DECLARE INTEGER CONSTANT FDV$K_KEX =	-41
DECLARE INTEGER CONSTANT FDV$K_KTW =	-42
DECLARE INTEGER CONSTANT FDV$K_KIL =	-43
DECLARE INTEGER CONSTANT FDV$K_TMO =	-44
DECLARE INTEGER CONSTANT FDV$K_LLI =	-45
DECLARE INTEGER CONSTANT FDV$K_VAL =	-47
DECLARE INTEGER CONSTANT FDV$K_IFU =	-48
DECLARE INTEGER CONSTANT FDV$K_SYS =	-49
DECLARE INTEGER CONSTANT FDV$K_INA =	-50
DECLARE INTEGER CONSTANT FDV$K_IOO = 	-51

!******************************************************
! Declare the FDV routines
!******************************************************
EXTERNAL LONG FUNCTION FDV$ADLVA
EXTERNAL LONG FUNCTION FDV$AFCX
EXTERNAL LONG FUNCTION FDV$AFVA
EXTERNAL LONG FUNCTION FDV$ATERM
EXTERNAL LONG FUNCTION FDV$AWKSP
EXTERNAL LONG FUNCTION FDV$BELL 
EXTERNAL LONG FUNCTION FDV$CANCL
EXTERNAL LONG FUNCTION FDV$CDISP
EXTERNAL LONG FUNCTION FDV$CLEAR
EXTERNAL LONG FUNCTION FDV$CLEAR_VA
EXTERNAL LONG FUNCTION FDV$DEL 
EXTERNAL LONG FUNCTION FDV$DFKBD
EXTERNAL LONG FUNCTION FDV$DISP
EXTERNAL LONG FUNCTION FDV$DISPW
EXTERNAL LONG FUNCTION FDV$DPCOM
EXTERNAL LONG FUNCTION FDV$DTERM 
EXTERNAL LONG FUNCTION FDV$DWKSP 
EXTERNAL LONG FUNCTION FDV$FCHAN
EXTERNAL LONG FUNCTION FDV$FIX_SCREEN
EXTERNAL LONG FUNCTION FDV$GET 
EXTERNAL LONG FUNCTION FDV$GETAF 
EXTERNAL LONG FUNCTION FDV$GETAL
EXTERNAL LONG FUNCTION FDV$GETDL
EXTERNAL LONG FUNCTION FDV$GETSC
EXTERNAL LONG FUNCTION FDV$ILTRM
EXTERNAL LONG FUNCTION FDV$LCHAN
EXTERNAL LONG FUNCTION FDV$LCLOS 
EXTERNAL LONG FUNCTION FDV$LEDOF 
EXTERNAL LONG FUNCTION FDV$LEDON 
EXTERNAL LONG FUNCTION FDV$LOAD 
EXTERNAL LONG FUNCTION FDV$LOPEN
EXTERNAL LONG FUNCTION FDV$NDISP
EXTERNAL LONG FUNCTION FDV$PFT 
EXTERNAL LONG FUNCTION FDV$PRINT_SCREEN
EXTERNAL LONG FUNCTION FDV$PUT 
EXTERNAL LONG FUNCTION FDV$PUTAL 
EXTERNAL LONG FUNCTION FDV$PUTD 
EXTERNAL LONG FUNCTION FDV$PUTDA
EXTERNAL LONG FUNCTION FDV$PUTL 
EXTERNAL LONG FUNCTION FDV$PUTSC 
EXTERNAL LONG FUNCTION FDV$READ 
EXTERNAL LONG FUNCTION FDV$RET 
EXTERNAL LONG FUNCTION FDV$RETAL 
EXTERNAL LONG FUNCTION FDV$RETCX
EXTERNAL LONG FUNCTION FDV$RETDI 
EXTERNAL LONG FUNCTION FDV$RETDN 
EXTERNAL LONG FUNCTION FDV$RETFL 
EXTERNAL LONG FUNCTION FDV$RETFN 
EXTERNAL LONG FUNCTION FDV$RETFO
EXTERNAL LONG FUNCTION FDV$RETLE
EXTERNAL LONG FUNCTION FDV$RFRSH
EXTERNAL LONG FUNCTION FDV$SCR_LENGTH
EXTERNAL LONG FUNCTION FDV$SCR_WIDTH
EXTERNAL LONG FUNCTION FDV$SIGOP 
EXTERNAL LONG FUNCTION FDV$SPADA 
EXTERNAL LONG FUNCTION FDV$SPOFF 
EXTERNAL LONG FUNCTION FDV$SPON 
EXTERNAL LONG FUNCTION FDV$SSIGQ 
EXTERNAL LONG FUNCTION FDV$SSRV 
EXTERNAL LONG FUNCTION FDV$STAT 
EXTERNAL LONG FUNCTION FDV$STERM
EXTERNAL LONG FUNCTION FDV$STIME
EXTERNAL LONG FUNCTION FDV$SWKSP 
EXTERNAL LONG FUNCTION FDV$TCHAN
EXTERNAL LONG FUNCTION FDV$USER_REFRESH
EXTERNAL LONG FUNCTION FDV$WAIT 
